<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"><head><meta http-equiv="Content-Type" content="text/html; charset=UTF-8" /><title>The Cpp Parser</title><link rel="stylesheet" href="synopsis.css" type="text/css" /><meta name="generator" content="DocBook XSL Stylesheets V1.73.2" /><link rel="start" href="index.html" title="Synopsis Tutorial" /><link rel="up" href="processors.html" title="Chapter 4. Processor Design" /><link rel="prev" href="idl-parser.html" title="The IDL Parser" /><link rel="next" href="cc-parser.html" title="The C Parser" /></head><body><div class="navheader"><table width="100%" summary="Navigation header"><tr><th colspan="3" align="center">The Cpp Parser</th></tr><tr><td width="20%" align="left"><a accesskey="p" href="idl-parser.html">Prev</a> </td><th width="60%" align="center">Chapter 4. Processor Design</th><td width="20%" align="right"> <a accesskey="n" href="cc-parser.html">Next</a></td></tr></table></div><div class="section" lang="en" xml:lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a id="cpp-parser"></a>The Cpp Parser</h2></div></div></div><p>The Cpp parser preprocesses IDL, C, and C++ files. As any normal preprocessor,
        it will generate a file suitable as input for a C or C++ parser, i.e. it 
        processes include and macro statements. However, it will store the encountered
        preprocessor directives in the ASG for further analysis.</p><p>As the list of included files may grow rather large, two mechanisms exist
        to restrict the number of files for which information is retained. The <span class="type">primary_file_only</span>
        parameter is used to indicate that only the top-level file being parsed should be included.
        The <span class="type">base_path</span> parameter, on the other hand, will restrict the number files if
        <span class="type">main_file_only</span> is set to <span class="type">False</span>. In this case, the <span class="type">base_path</span>
        is used as a prefix, and only those file whose name starts with that prefix are marked as 
        <span class="type">main</span>.
      </p><p>For each included file, a <span class="type">SourceFile</span> object is created and added
        to the parent's <span class="type">Include</span> list. Further, all macro declarations, as well
        as macro calls, are recorded. While most useful in conjunction with the C and Cxx processors,
        these data can be of use stand-alone, too. For example consider a tool that reports file
        dependencies based on <span class="type">#include</span> statements. The Dot formatter (see <a class="xref" href="dot-formatter.html" title="The Dot Formatter">the section called “The Dot Formatter”</a>)
        can generate a file dependency graph from the Cpp processor output alone:
      </p><div class="mediaobject"><img src="images/Files.png" width="432" /></div><p>Whenever the code to be parsed includes <span class="emphasis"><em>system headers</em></span>, the parser needs
        to know about their location(s), and likely also about <span class="emphasis"><em>system macro</em></span> definitions
        that may be in effect.</p><p>The <span class="type">Cpp</span> parser provides two parameters to specify this emulation process, 
        <code class="varname">emulate_compiler</code> and <code class="varname">compiler_flags</code>. To illustrate their use,
        let us probe for the system flags that get generated:</p><pre class="screen">
<code class="prompt">&gt; </code>synopsis --probe -p Cpp -Wp,--emulate-compiler=g++
Compiler: g++
Flags:
Language: C++
Header search path:
  /usr/lib/gcc/i386-redhat-linux/4.1.2/../../../../include/c++/4.1.2
  ...
  /usr/include

Macro definitions:
  __STDC__=1
  __cplusplus=1
  ...
    </pre><p>Sometimes it isn't enough to have the compiler name itself. Some flags may modify the header search path,
      or the predefined macros. For example, GCC can be instructed not to consider system headers at all:</p><pre class="screen">
<code class="prompt">&gt; </code>synopsis --probe -p Cpp -Wp,--emulate-compiler=g++ -Wp,compiler-flags=[\"-nostdinc\"]
Compiler: g++
Flags: -nostdinc
Language: C++
Header search path:


Macro definitions:
  __STDC__=1
  __cplusplus=1
  ...
    </pre><p>Here, the set of predefined header search paths is empty. Note, that the 
        <code class="option">--compiler-flags</code> option (which, as you may remember, maps to the
        <code class="varname">compiler_flags</code> processor parameter) expects a (Python) list.
        Therefor, we use the form without the leading dashes, so we can pass Python code 
        as argument (See <a class="xref" href="options.html" title="Option Handling">the section called “Option Handling”</a> for details), with appropriate quoting.</p><p>For details about the parameters see <a class="xref" href="Cpp-Parser-ref.html" title="Synopsis.Parsers.Cpp.Parser">the section called “Synopsis.Parsers.Cpp.Parser”</a>.</p></div><div class="navfooter"><table width="100%" summary="Navigation footer"><tr><td width="40%" align="left"><a accesskey="p" href="idl-parser.html">Prev</a> </td><td width="20%" align="center"><a accesskey="u" href="processors.html">Up</a></td><td width="40%" align="right"> <a accesskey="n" href="cc-parser.html">Next</a></td></tr><tr><td width="40%" align="left" valign="top">The IDL Parser </td><td width="20%" align="center"><a accesskey="h" href="index.html">Home</a></td><td width="40%" align="right" valign="top"> The C Parser</td></tr></table></div></body></html>
